<template>
  <div>
    <h2>{{ title }}</h2>
    <template v-if="loading">
      <div>Loading..</div>
    </template>
    <template v-else>
      <div class="chart-area">
        <template v-if="type === 'line'">
          <line-chart :chart-data="dataCollection" :styles="chartStyles" :options="chartOptions"></line-chart>
        </template>
        <template v-if="type === 'bar'">
          <bar-chart :chart-data="dataCollection" :styles="chartStyles" :options="chartOptions"></bar-chart>
        </template>
      </div>
    </template>
  </div>
</template>

<script>
import moment from 'moment'
import { queryBuilder } from '@/core/query/query'
import { generateTimeList } from '@/core/query/utils'
import LineChart from '@/detail/mixins/LineChart'
import BarChart from '@/detail/mixins/BarChart'

export default {
  props: {
    type: {
      type: String,
      default: 'line',
    },
    title: {
      type: String,
      default: 'titulo',
    },

    layer: {
      type: String,
      required: true,
    },

    level: {
      type: String,
      required: false,
    },

    color: {
      type: String,
      default: '#f87979',
    },

    datetime: {
      type: Number,
      required: true,
    },

    transform: {
      type: String,
      default: 'identity'
    },
  },

  data() {
    return {
      loading: true,
      queryData: null,
    }
  },

  computed: {
    dataCollection: {
      get() {
        return {
          datasets: [{
            label: this.title,
            backgroundColor: this.color,
            data: this.chartData,
          }]
        }
      },
    },

    chartData: {
      get() {
        if(this.queryData === null) return []

        let data = this.queryData[this.layer]
        if(this.level) {
          data = data.filter((item) => { return item.level === this.level })
        }
        return data.map((item) => { return { y: this[this.transform](item.value), t: item.time } })
      },
    },

    chartStyles: {
      get() {
        return {
          height: '200px',
          position: 'relative',
        }
      },
    },

    chartOptions: {
      get() {
        return {
          responsive: true,
          maintainAspectRatio: false,
          scales: {
            xAxes: [{
              type: 'time',
              time: {
                unit: 'hour'
              }
            }]
          }
        }
      },
    },
  },

  methods: {
    get() {
      return queryBuilder(this.layer)
        .setLatitude(this.$route.params.latitude)
        .setLongitude(this.$route.params.longitude)
        .setReferenceTime(moment.unix(this.datetime).format('YYYY-MM-DDTHH:00:00[Z]'))
        .setTime(generateTimeList(moment().unix(this.datetime), 48))
        .execute()
    },

    kelvinToCelsius(value) {
      window.console.log('kelvin')
      return value !== null ? value - 273.5 : null
    },

    pascalTohPa(value) {
      return value !== null ? value / 100 : null
    },

    identity(value) {
      return value
    },
  },

  mounted() {
    this.get().then((response) => {
      this.queryData = response.data.properties
      this.loading = false
    })
  },

  components: {
    LineChart,
    BarChart,
  },
}
</script>
